Search results

Grid Data in Chart in JavaScript (ES5) Chart control

29 Mar 2023 / 2 minutes to read

You can visualize the data that returned by grid in chart.

To visualize the data in chart, follow the given steps:

Step 1:

Initialize the grid with datasource.

Step 2:

By using the grid’s actionComplete event and getCurrentViewRecords method, you can get the current page records. By using the grid’s databound event, you can update the current page records into the chart’s datasource and visualize the grid data in chart.

Source
Preview
index.js
index.html
Copied to clipboard
var chart = new ej.charts.Chart();
    var data = new ej.data.DataManager(orderData).executeLocal(new ej.data.Query().take(100));
     var grid = new ej.grids.Grid({
        
            dataSource: data,
            allowPaging: true,
            pageSettings: { pageSize: 10 },
            columns: [
                { field: 'OrderDate', headerText: 'Order Date', width: 130, format: 'yMd', textAlign: 'right' },
                { field: 'Freight', width: 120, format: 'C2', textAlign: 'right' }
            ],
        dataBound: function() {
        chart = new ej.charts.Chart({
            //Initializing Primary X Axis
            primaryXAxis: {
            valueType: 'DateTime',
            },
            series: [
            {
                type: 'Column',
                dataSource: grid.getCurrentViewRecords(),
                xName: 'OrderDate', width: 2, marker: {
                    visible: true,
                    width: 10,
                    height: 10
                },
                yName: 'Freight', name: 'Germany',
            },
        ],

          }, '#Chart');
        },
         actionComplete: function(args)  {
                if (args.requestType === 'paging') {
                 chart.series[0].dataSource =  grid.getCurrentViewRecords();
                   chart.refresh();
                }
         }      
        }, '#Grid');
Copied to clipboard
<!DOCTYPE html><html lang="en"><head>
            
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/21.1.35/material.css" rel="stylesheet">
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/21.1.35/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>
    
    <div class="control-section">
      <div id="link">
          <a id="category" style="visibility:hidden; display:inline-block">
            Sales by Category 
      </a>
          <p style="visibility:hidden; display:inline-block" id="symbol">&nbsp;&gt;&gt;&nbsp;</p>
          <p id="text" style="display:inline-block;"></p>
      </div>
      <div id="container"></div>
  </div>
  
 
<script>
var ele = document.getElementById('container');
if(ele) {
    ele.style.visibility = "visible";
 }   
        </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Grid data chart in React Chart component

19 Sep 202424 minutes to read

You can visualize the data that returned by grid in chart.

To visualize the data in chart, follow the given steps:

Step 1:

Initialize the grid with datasource.

Step 2:

By using the grid’s actionComplete event and getCurrentViewRecords method, you can get the current page records.
By using the grid’s databound event, you can update the current page records into the chart’s datasource and visualize the grid data in chart.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject, ColumnSeries, DateTime } from '@syncfusion/ej2-react-charts';
import { ColumnDirective, ColumnsDirective, GridComponent, Page, Selection } from '@syncfusion/ej2-react-grids';
import { data } from './datasource';
function App() {
    const pageSettings = { pageSize: 10 };
    var grid;
    var chart;
    const primaryxAxis = { valueType: 'DateTime', intervalType: 'Days' };
    function actionComplete(args) {
        if (args.requestType === 'paging') {
            chart.series[0].dataSource = grid.getCurrentViewRecords();
            chart.refresh();
        }
    };
    function dataBound(args) {
        chart.series[0].dataSource = grid.getCurrentViewRecords();
    };
    
    return (<div className='row'>
        <div className="col-sm-4">
            <GridComponent ref={g => grid = g} id='grid' dataSource={data} allowPaging={true} pageSettings={pageSettings} actionComplete={actionComplete.bind(this)} dataBound={dataBound.bind(this)}>
                <ColumnsDirective>
                    <ColumnDirective field='OrderDate' headerText='Order Date' width='130' format='yMd' textAlign="Right" />
                    <ColumnDirective field='Freight' width='120' format='C2' textAlign='Right' />
                </ColumnsDirective>
                <Inject services={[Page, Selection]} />
            </GridComponent>
        </div>
        <div className="col-sm-4">
            <ChartComponent ref={g => chart = g} id='charts' primaryXAxis={primaryxAxis}>
                <Inject services={[ColumnSeries, DateTime]} />
                <SeriesCollectionDirective>
                    <SeriesDirective name='Germany' xName='OrderDate' yName='Freight' width={2} type='Column' marker={{ visible: true, width: 10, height: 10 }}>
                    </SeriesDirective>
                </SeriesCollectionDirective>
            </ChartComponent>
        </div>
    </div>);
}
;
export default App;
ReactDOM.render(<App />, document.getElementById('charts'));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject, AxisModel, Chart, ColumnSeries, DateTime } from '@syncfusion/ej2-react-charts';
import { ColumnDirective, ColumnsDirective, GridComponent, Page, PageSettingsModel, Selection, Grid, ActionEventArgs } from '@syncfusion/ej2-react-grids';
import { data } from './datasource';
function App() {
    const pageSettings: PageSettingsModel = { pageSize: 10 }
    var grid: Grid | null;
    var chart: Chart | null;
    const primaryxAxis: AxisModel = { valueType: 'DateTime', intervalType: 'Days' };
    function actionComplete(args: ActionEventArgs) {
        if (args.requestType === 'paging') {
            (chart as Chart).series[0].dataSource = (grid as Grid).getCurrentViewRecords();
            (chart as Chart).refresh();
        }
    };
    function dataBound(args: any): void {
        (chart as Chart).series[0].dataSource = (grid as Grid).getCurrentViewRecords();
    };

    return (<div className='row'>
        <div className="col-sm-4">
            <GridComponent ref={g => grid = g} id='grid' dataSource={data} allowPaging={true} pageSettings={pageSettings} actionComplete={actionComplete.bind(this)} dataBound={dataBound.bind(this)}>
                <ColumnsDirective>
                    <ColumnDirective field='OrderDate' headerText='Order Date' width='130' format='yMd' textAlign="Right" />
                    <ColumnDirective field='Freight' width='120' format='C2' textAlign='Right' />
                </ColumnsDirective>
                <Inject services={[Page, Selection]} />
            </GridComponent>
        </div>
        <div className="col-sm-4">
            <ChartComponent ref={g => chart = g} id='charts' primaryXAxis={primaryxAxis}>
                <Inject services={[ColumnSeries, DateTime]} />
                <SeriesCollectionDirective>
                    <SeriesDirective name='Germany' xName='OrderDate' yName='Freight' width={2} type='Column' marker={{ visible: true, width: 10, height: 10 }}>
                    </SeriesDirective>
                </SeriesCollectionDirective>
            </ChartComponent>
        </div>
    </div>)

};
export default App;
ReactDOM.render(<App />, document.getElementById('charts'));
export let data = [
    {
        'OrderDate': '1996-07-06',
        'ShippedDate': '1996-07-16',
        'Freight': 32.38
    },
    {
        'OrderDate': '1996-07-07',
        'ShippedDate': '1996-07-10',
        'Freight': 11.61
    },
    {
        'OrderDate': '1996-07-08',
        'ShippedDate': '1996-07-12',
        'Freight': 65.83
    },
    {
        'OrderDate': '1996-07-09',
        'ShippedDate': '1996-07-15',
        'Freight': 41.34
    },
    {
        'OrderDate': '1996-07-10',
        'ShippedDate': '1996-07-11',
        'Freight': 51.3
    },
    {
        'OrderDate': '1996-07-11',
        'ShippedDate': '1996-07-16',
        'Freight': 58.17
    },
    {
        'OrderDate': '1996-07-12',
        'ShippedDate': '1996-07-23',
        'Freight': 22.98
    },
    {
        'OrderDate': '1996-07-13',
        'ShippedDate': '1996-07-15',
        'Freight': 148.33
    },
    {
        'OrderDate': '1996-07-14',
        'ShippedDate': '1996-07-17',
        'Freight': 13.97
    },
    {
        'OrderDate': '1996-07-15',
        'ShippedDate': '1996-07-22',
        'Freight': 81.91
    },
    {
        'OrderDate': '1996-07-16',
        'ShippedDate': '1996-07-23',
        'Freight': 140.51
    },
    {
        'OrderDate': '1996-07-17',
        'ShippedDate': '1996-07-25',
        'Freight': 3.25
    },
    {
        'OrderDate': '1996-07-18',
        'ShippedDate': '1996-07-29',
        'Freight': 55.09
    },
    {
        'OrderDate': '1996-07-19',
        'ShippedDate': '1996-07-30',
        'Freight': 3.05
    },
    {
        'OrderDate': '1996-07-20',
        'ShippedDate': '1996-07-25',
        'Freight': 48.29
    },
    {
        'OrderDate': '1996-07-21',
        'ShippedDate': '1996-07-31',
        'Freight': 146.06
    },
    {
        'OrderDate': '1996-07-22',
        'ShippedDate': '1996-08-23',
        'Freight': 3.67
    },
    {
        'OrderDate': '1996-07-23',
        'ShippedDate': '1996-08-12',
        'Freight': 55.28
    },
    {
        'OrderDate': '1996-07-24',
        'ShippedDate': '1996-07-31',
        'Freight': 25.73
    },
    {
        'OrderDate': '1996-07-25',
        'ShippedDate': '1996-08-06',
        'Freight': 208.58
    },
    {
        'OrderDate': '1996-07-26',
        'ShippedDate': '1996-08-02',
        'Freight': 66.29
    },
    {
        'OrderDate': '1996-07-27',
        'ShippedDate': '1996-08-09',
        'Freight': 4.56
    },
    {
        'OrderDate': '1996-07-29',
        'ShippedDate': '1996-08-02',
        'Freight': 136.54
    },
    {
        'OrderDate': '1996-07-30',
        'ShippedDate': '1996-08-30',
        'Freight': 4.54
    },
    {
        'OrderDate': '1996-07-31',
        'ShippedDate': '1996-08-06',
        'Freight': 98.03
    },
    {
        'OrderDate': '1996-08-01',
        'ShippedDate': '1996-08-12',
        'Freight': 76.07
    },
    {
        'OrderDate': '1996-08-02',
        'ShippedDate': '1996-08-16',
        'Freight': 6.01
    },
    {
        'OrderDate': '1996-08-03',
        'ShippedDate': '1996-08-09',
        'Freight': 26.93
    },
    {
        'OrderDate': '1996-08-04',
        'ShippedDate': '1996-08-14',
        'Freight': 13.84
    },
    {
        'OrderDate': '1996-08-05',
        'ShippedDate': '1996-08-13',
        'Freight': 125.77
    },
    {
        'OrderDate': '1996-08-06',
        'ShippedDate': '1996-08-16',
        'Freight': 92.69
    },
    {
        'OrderDate': '1996-08-07',
        'ShippedDate': '1996-08-16',
        'Freight': 25.83
    },
    {
        'OrderDate': '1996-08-08',
        'ShippedDate': '1996-09-12',
        'Freight': 8.98
    },
    {
        'OrderDate': '1996-08-09',
        'ShippedDate': '1996-08-21',
        'Freight': 2.94
    },
    {
        'OrderDate': '1996-08-10',
        'ShippedDate': '1996-08-21',
        'Freight': 12.69
    },
    {
        'OrderDate': '1996-08-11',
        'ShippedDate': '1996-08-28',
        'Freight': 12.76
    },
    {
        'OrderDate': '1996-08-12',
        'ShippedDate': '1996-09-03',
        'Freight': 7.45
    },
    {
        'OrderDate': '1996-08-13',
        'ShippedDate': '1996-08-28',
        'Freight': 22.77
    },
    {
        'OrderDate': '1996-08-14',
        'ShippedDate': '1996-09-03',
        'Freight': 79.7
    },
    {
        'OrderDate': '1996-08-15',
        'ShippedDate': '1996-09-04',
        'Freight': 6.4
    }
];
export let data: Object[] = [
    {
        'OrderDate': '1996-07-06',
        'ShippedDate': '1996-07-16',
        'Freight': 32.38
    },
    {
        'OrderDate': '1996-07-07',
        'ShippedDate': '1996-07-10',
        'Freight': 11.61
    },
    {
        'OrderDate': '1996-07-08',
        'ShippedDate': '1996-07-12',
        'Freight': 65.83
    },
    {
        'OrderDate': '1996-07-09',
        'ShippedDate': '1996-07-15',
        'Freight': 41.34
    },
    {
        'OrderDate': '1996-07-10',
        'ShippedDate': '1996-07-11',
        'Freight': 51.3
    },
    {
        'OrderDate': '1996-07-11',
        'ShippedDate': '1996-07-16',
        'Freight': 58.17
    },
    {
        'OrderDate': '1996-07-12',
        'ShippedDate': '1996-07-23',
        'Freight': 22.98
    },
    {
        'OrderDate': '1996-07-13',
        'ShippedDate': '1996-07-15',
        'Freight': 148.33
    },
    {
        'OrderDate': '1996-07-14',
        'ShippedDate': '1996-07-17',
        'Freight': 13.97
    },
    {
        'OrderDate': '1996-07-15',
        'ShippedDate': '1996-07-22',
        'Freight': 81.91
    },
    {
        'OrderDate': '1996-07-16',
        'ShippedDate': '1996-07-23',
        'Freight': 140.51
    },
    {
        'OrderDate': '1996-07-17',
        'ShippedDate': '1996-07-25',
        'Freight': 3.25
    },
    {
        'OrderDate': '1996-07-18',
        'ShippedDate': '1996-07-29',
        'Freight': 55.09
    },
    {
        'OrderDate': '1996-07-19',
        'ShippedDate': '1996-07-30',
        'Freight': 3.05
    },
    {
        'OrderDate': '1996-07-20',
        'ShippedDate': '1996-07-25',
        'Freight': 48.29
    },
    {
        'OrderDate': '1996-07-21',
        'ShippedDate': '1996-07-31',
        'Freight': 146.06
    },
    {
        'OrderDate': '1996-07-22',
        'ShippedDate': '1996-08-23',
        'Freight': 3.67
    },
    {
        'OrderDate': '1996-07-23',
        'ShippedDate': '1996-08-12',
        'Freight': 55.28
    },
    {
        'OrderDate': '1996-07-24',
        'ShippedDate': '1996-07-31',
        'Freight': 25.73
    },
    {
        'OrderDate': '1996-07-25',
        'ShippedDate': '1996-08-06',
        'Freight': 208.58
    },
    {
        'OrderDate': '1996-07-26',
        'ShippedDate': '1996-08-02',
        'Freight': 66.29
    },
    {
        'OrderDate': '1996-07-27',
        'ShippedDate': '1996-08-09',
        'Freight': 4.56
    },
    {
        'OrderDate': '1996-07-29',
        'ShippedDate': '1996-08-02',
        'Freight': 136.54
    },
    {
        'OrderDate': '1996-07-30',
        'ShippedDate': '1996-08-30',
        'Freight': 4.54
    },
    {
        'OrderDate': '1996-07-31',
        'ShippedDate': '1996-08-06',
        'Freight': 98.03
    },
    {
        'OrderDate': '1996-08-01',
        'ShippedDate': '1996-08-12',
        'Freight': 76.07
    },
    {
        'OrderDate': '1996-08-02',
        'ShippedDate': '1996-08-16',
        'Freight': 6.01
    },
    {
        'OrderDate': '1996-08-03',
        'ShippedDate': '1996-08-09',
        'Freight': 26.93
    },
    {
        'OrderDate': '1996-08-04',
        'ShippedDate': '1996-08-14',
        'Freight': 13.84
    },
    {
        'OrderDate': '1996-08-05',
        'ShippedDate': '1996-08-13',
        'Freight': 125.77
    },
    {
        'OrderDate': '1996-08-06',
        'ShippedDate': '1996-08-16',
        'Freight': 92.69
    },
    {
        'OrderDate': '1996-08-07',
        'ShippedDate': '1996-08-16',
        'Freight': 25.83
    },
    {
        'OrderDate': '1996-08-08',
        'ShippedDate': '1996-09-12',
        'Freight': 8.98
    },
    {
        'OrderDate': '1996-08-09',
        'ShippedDate': '1996-08-21',
        'Freight': 2.94
    },
    {
        'OrderDate': '1996-08-10',
        'ShippedDate': '1996-08-21',
        'Freight': 12.69
    },
    {
        'OrderDate': '1996-08-11',
        'ShippedDate': '1996-08-28',
        'Freight': 12.76
    },
    {
        'OrderDate': '1996-08-12',
        'ShippedDate': '1996-09-03',
        'Freight': 7.45
    },
    {
        'OrderDate': '1996-08-13',
        'ShippedDate': '1996-08-28',
        'Freight': 22.77
    },
    {
        'OrderDate': '1996-08-14',
        'ShippedDate': '1996-09-03',
        'Freight': 79.7
    },
    {
        'OrderDate': '1996-08-15',
        'ShippedDate': '1996-09-04',
        'Freight': 6.4
    }
];

Grid data chart in Angular Chart component

20 Sep 20226 minutes to read

You can visualize the data that returned by grid in chart.

To visualize the data in chart, follow the given steps:

Step 1:

Initialize the grid with datasource.

Step 2:

By using the grid’s actionComplete event and getCurrentViewRecords method, you can get the current page records.
By using the grid’s databound event, you can update the current page records into the chart’s datasource and visualize the grid data in chart.

import { Component, OnInit, ViewChild } from '@angular/core';
import { IDragCompleteEventArgs, ChartComponent } from '@syncfusion/ej2-angular-charts';
import { GridComponent, ActionEventArgs } from '@syncfusion/ej2-angular-grids';
import { Query, DataManager } from '@syncfusion/ej2-data';
import { orderData } from 'datasource.ts';
@Component({
    selector: 'app-container',
    template:
    `<ejs-grid #grid [dataSource]='data' [allowPaging]="true" [pageSettings]='pageSettings' (dataBound)='dataBound()'
    (actionComplete)='actionComplete($event)'>
                 <e-columns>
                    <e-column field='OrderDate' headerText='Order Date' width=130 format='yMd' textAlign='right'></e-column>
                    <e-column field='Freight' width=120 format='C2' textAlign='right'></e-column>
                </e-columns>
    </ejs-grid>
    <ejs-chart #chart id="chart-container" [primaryXAxis]='primaryXAxis'[primaryYAxis]='primaryYAxis' [title]='title'>
        <e-series-collection>
            <e-series  type='Line' xName='OrderDate' yName='Freight' name='dataview' [marker]='marker'></e-series>>
        </e-series-collection>
         </ejs-chart>`

})
export class AppComponent implements OnInit {
    public primaryXAxis: Object;
    public chartData: Object[];
    public data: Object[];
    public title: string;
    public marker: Object;
    public primaryYAxis: Object;
    public pageSettings: Object;
    @ViewChild('chart')
    public chart: ChartComponent;
     @ViewChild('grid')
    public grid: GridComponent;
    ngOnInit(): void {
        this.data = new DataManager(orderData as JSON[]).executeLocal(new Query().take(100));
        this.pageSettings = { pageSize: 10 };
    }
    dataBound() {
           this.chart.primaryXAxis = {
            valueType: 'DateTime',
           };
          this.chart.series[0].marker = { visible: true}
          this.chart.series[0].xName = 'OrderDate';
          this.chart.series[0].yName = 'Freight';
          this.chart.series[0].dataSource = this.grid.getCurrentViewRecords();
    }
  public actionComplete(args: ActionEventArgs):void {
                if (args.requestType === 'paging') {
                 this.chart.series[0].dataSource =  this.grid.getCurrentViewRecords();
                 this.chart.refresh();
    }
}
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { ChartModule } from '@syncfusion/ej2-angular-charts';
import { GridModule } from '@syncfusion/ej2-angular-grids';
import { PageService, SortService, FilterService, GroupService  } from '@syncfusion/ej2-angular-grids';
import { AccumulationChartModule } from '@syncfusion/ej2-angular-charts';
import { PieSeriesService, AccumulationTooltipService, AccumulationDataLabelService } from '@syncfusion/ej2-angular-charts';
import { LineSeriesService, DateTimeService, DataLabelService,StackingColumnSeriesService,CategoryService, ChartShape,
       StepAreaSeriesService,SplineSeriesService, ChartAnnotationService, LegendService, TooltipService, StripLineService,
       SelectionService,ScatterSeriesService
    } from '@syncfusion/ej2-angular-charts';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule, ChartModule, AccumulationChartModule, GridModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent],
    providers: [ LineSeriesService, DateTimeService, DataLabelService, StackingColumnSeriesService,CategoryService,
               StepAreaSeriesService, SplineSeriesService, ChartAnnotationService, LegendService, TooltipService, StripLineService,
               PieSeriesService, AccumulationTooltipService, AccumulationDataLabelService, SelectionService,ScatterSeriesService
               ,PageService]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);